unit tn4001;

{
 Telnet 5250 emulation (C) 1999-2005, by Paul TOTH <tothpaul@free.fr>
  http://tothpaul.free.fr
}

{
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Clipbrd,
  StdCtrls, ComCtrls, ExtCtrls, Menus, Dialogs, TN5250, Frm5250, Winsock;

type
  TForm1 = class(TForm)
    FontDialog1: TFontDialog;
    OpenDlg: TOpenDialog;
    SaveDlg: TSaveDialog;
    MainMenu1: TMainMenu;
    Connexion1: TMenuItem;
    RemoteSystem1: TMenuItem;
    Options1: TMenuItem;
    Font1: TMenuItem;
    Black1: TMenuItem;
    Blink1: TMenuItem;
    Blue1: TMenuItem;
    Green1: TMenuItem;
    Pink1: TMenuItem;
    Red1: TMenuItem;
    Turquoise1: TMenuItem;
    White1: TMenuItem;
    Yellow1: TMenuItem;
    Colors1: TMenuItem;
    N1: TMenuItem;
    Quit1: TMenuItem;
    N2: TMenuItem;
    SaveScreen1: TMenuItem;
    LoadScreen1: TMenuItem;
    About1: TMenuItem;
    ColorDlg: TColorDialog;
    N4: TMenuItem;
    Disconnect1: TMenuItem;
    RegisterOptions1: TMenuItem;
    AddIcon1: TMenuItem;
    About2: TMenuItem;
    N3: TMenuItem;
    HowtoUninstall1: TMenuItem;
    FAQ1: TMenuItem;
    Keyboard1: TMenuItem;
    Edit1: TMenuItem;
    Copy1: TMenuItem;
    Past1: TMenuItem;
    ExportasHTML1: TMenuItem;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    Frame5250: TFrame5250;
    ShowAttributes1: TMenuItem;
    Usedport1: TMenuItem;
    N5: TMenuItem;
    Copyastext1: TMenuItem;
    Copyashtml1: TMenuItem;
    Copyasbitmap1: TMenuItem;
    procedure DSP5250PutGet(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure Font1Click(Sender: TObject);
    procedure RemoteSystem1Click(Sender: TObject);
    procedure SaveScreen1Click(Sender: TObject);
    procedure LoadScreen1Click(Sender: TObject);
    procedure Quit1Click(Sender: TObject);
    procedure Black1Click(Sender: TObject);
    procedure Disconnect1Click(Sender: TObject);
    procedure RegisterOptions1Click(Sender: TObject);
    procedure AddIcon1Click(Sender: TObject);
    procedure HowtoUninstall1Click(Sender: TObject);
    procedure Keyboard1Click(Sender: TObject);
    procedure Copy1Click(Sender: TObject);
    procedure Past1Click(Sender: TObject);
    procedure ExportasHTML1Click(Sender: TObject);
    procedure ShowAttributes1Click(Sender: TObject);
    procedure Usedport1Click(Sender: TObject);
    procedure Copyastext1Click(Sender: TObject);
    procedure Copyashtml1Click(Sender: TObject);
    procedure Copyasbitmap1Click(Sender: TObject);
  private
    { Dclarations prives }
    Status:(stDATA,stIAC,stDO,stSB,stWILL,stHEAD);
    Data:string;
    SubNegoce:String;

    Head:THead5250;

    Data2:string;

    SysName:string;
    DevName:string;
    DevName0:string;

    fSocket:integer;
    fSndBuf:string;

    procedure WMSysCommand(Var Msg:TWMSysCommand); message wm_syscommand;
    procedure WMSocket(Var Msg:TMessage); message wm_user;
    procedure CallServer;
    procedure Connected;
    procedure ReadSocket;
    procedure WriteSocket;
    procedure Disconnected(ErrNo:integer);
  public
    { Dclarations publiques }
    procedure Error(Msg:string);
    procedure WSError(Msg:string);
    procedure SaveFMT(FileName:string);
    procedure LoadFMT(FileName:string);
    procedure ExFmt;
  end;

var
  Form1: TForm1;

const
 key=HKEY_CURRENT_USER;
 path='Software\MySoft\TN400';

implementation

uses EBCDIC, tn4002, RegEdit, Links, tn4003;

{$R *.DFM}


function INetAddr(Host:string):integer;
var
 pHost:PChar;
 HostEnt:PHostEnt;
begin
 if Host='' then begin
  Result:=INADDR_NONE;
 end else begin
  pHost:=PChar(Host);
  Result:=inet_addr(pHost);
  if Result=INADDR_NONE then begin
   HostEnt:=gethostbyname(pHost);
   if HostEnt<>nil then Result:=integer(pointer(HostEnt^.h_addr^)^);
  end;
 end;
end;

procedure TForm1.WSError(Msg:string);
var
 e:integer;
begin
 e:=WSAGetLastError;
 if e<>WSAEWOULDBLOCK then Error(Msg+' (WINSOCK ERROR #'+IntToStr(e)+')');
end;

procedure TForm1.WMSocket(Var Msg:TMessage);
begin
 case Msg.LParam of
  FD_CONNECT: Connected;
  FD_READ   : ReadSocket;
  FD_WRITE  : WriteSocket;
  FD_CLOSE  : Disconnected(0);
  else Disconnected(Msg.lParamHi);
 end;
end;

procedure TForm1.Connected;
begin
 DevName0:=DevName; // reset original DevName
 Status:=stDATA;
 Data:='';
 Frame5250.Status:='Connected to host server...';
 RemoteSystem1.Enabled:=False;
 Disconnect1.Enabled:=True;
end;

procedure TForm1.ReadSocket;
var
 b:array[0..2047] of char;
 l:integer;
 i:integer;
 c:char;
 r:string;
begin
 l:=recv(fSocket,b,SizeOf(b),0);
 if l<0 then WSError('Erreur de lecture');
 if l=0 then begin
  Disconnected(0);
  exit;
 end;
 for i:=0 to l-1 do begin
  c:=b[i];
  case Status of

   stDATA: if c=tnIAC then Status:=stIAC else Data:=Data+c; // 5250 stream

   stIAC: case c of // IAC sequence
    tnIAC : begin Data:=Data+c; Status:=stDATA; end;
    tnDO  : Status:=stDO;
    tnSB  : begin Status:=stSB; SubNegoce:=''; end;
    tnSE  : ;
    tnWILL: Status:=stWill;
    tnEND : begin
             Status:=stDATA;
             ExFmt;
             Data:='';
            end;
    else begin Error('<!> IAC #'+IntToStr(ord(c))); exit; end;
   end;

   stDO: begin // DO - WILL/WONT
    Status:=stDATA;
    case c of
     tnBIN     : begin r:=tnIAC+tnWILL+tnBIN;       end;
     tnTERMTYPE: begin r:=tnIAC+tnWILL+tnTERMTYPE;  end;
     tnEOR     : begin r:=tnIAC+tnWILL+tnEOR;       end;
     tnNEWENV  : begin r:=tnIAC+tnWILL+c;           end;
     tnTIMING  : begin r:=tnIAC+tnWILL+tnTIMING;    end;
     else begin
      Error('<!> IAC DO +#'+IntToStr(Ord(c)));
      exit;
     end;
    end;
   end;

   stWILL: begin   // WILL - DO/DONT
    Status:=stDATA;
    case c of
     tnBIN        : begin r:=tnIAC+tnDO+tnBIN;         end;
     tnECHO       : begin r:=tnIAC+tnDO+tnECHO;        end;
     tnSUPPRESS_GA: begin r:=tnIAC+tnDO+tnSUPPRESS_GA; end;
     tnEOR        : begin r:=tnIAC+tnDO+tnEOR;         end;
     tnNEWENV     : begin r:=tnIAC+tnDO+tnNEWENV;      end;
     tnTIMING     : begin r:=tnIAC+tnDO+tnTIMING;      end;
     else begin
      Error('<!> IAC WILL +#'+IntToStr(Ord(c)));
      exit;
     end;
    end;
   end;

  // Sub-negoce
   stSB: begin
    SubNegoce:=SubNegoce+c;
    if c=tnSE then begin
     if SubNegoce=tnTERMTYPE+ttSEND+tnIAC+tnSE then begin
      r:=tnIAC+tnSB+tnTERMTYPE+ttIS+TERM+tnIAC+tnSE;
     end else
     if SubNegoce[1]=tnNEWENV then begin
     { #39    #01  #03 #73#66#77#82#83#69#69#68 #127#13#212#104#179#11#04#04#00 #03 #255 }
     { NEWENV SEND #03 "IBMRSEED12345678"#0 #03               ?????????????????????????????????? IAC  }
      r:=tnIAC+tnSB+tnNEWENV+ttIS+
         tnVAR+'DEVNAME'+tnVAL+{'TN5250'}DevName0; DevName0:=DevName0+'0'+
         tnIAC+tnSE;
     end else begin
      Error('<!> SubNegoce #'+IntToStr(ord(SubNegoce[1]))+ ' '+SubNegoce);
      exit;
     end;
     Status:=stDATA;
    end;
   end;

  // unsupported ?
   else begin
    Error('IAC #'+IntToStr(ord(c)));
    exit;
   end;

  end; //  case b[i]

  if r<>'' then begin
   fSndBuf:=fSndBuf+r;
   r:='';
  end;

 end; //  For b[i]
 WriteSocket;
end;

procedure TForm1.WriteSocket;
var
 l,i:integer;
begin
 l:=Length(fSndBuf);
 if l=0 then exit;
 i:=send(fSocket,fSndBuf[1],l,0);
 if i<0 then WSError('Erreur d''criture');
 if i=0 then Disconnected(0) else begin
  Delete(fSndBuf,1,i);
 end;
end;

procedure TForm1.Error(Msg:string);
begin
 Disconnected(0);
 fSocket:=INVALID_SOCKET;
 ShowMessage(Msg);
end;

procedure TForm1.WMSysCommand(Var Msg:TWMSysCommand);
begin
// fix F10
 if Msg.CmdType=SC_KEYMENU then Frame5250.Perform(WM_KEYDOWN,VK_F10,0) else inherited;
end;

procedure TForm1.SaveFMT(FileName:string);
var
 fs:TFileStream;
 Size:integer;
begin
 fs:=TFileStream.Create(FileName,fmCreate);
 Size:=Length(Data2);
 fs.WriteBuffer(Size,sizeOf(Size));
 fs.WriteBuffer(Data2[1],Size);
 fs.Free;
end;

procedure TForm1.LoadFMT(FileName:string);
var
 fs:TFileStream;
 Size:integer;
begin
 fs:=TFileStream.Create(FileName,fmOpenRead);
 fs.ReadBuffer(Size,sizeOf(Size));
 SetLength(Data,Size);
 fs.ReadBuffer(Data[1],Size);
 fs.Free;
end;

procedure TForm1.ExFmt;
begin
 Data2:=Data;
 if Length(Data)<SizeOf(Head) then begin
  ShowMessage('Invalide data !');
  exit;
 end;
 Move(Data[1],Head,SizeOf(Head));
 Delete(Data,1,SizeOf(Head));
 Frame5250.Flags :=Head.Flag;
 Frame5250.OpCode:=Head.Code;
 Frame5250.Stream:=Data;
 Frame5250.SetFocus;
end;

procedure TForm1.DSP5250PutGet(Sender: TObject);
var
 Head:THead5250;
 IAC :string;

 function DoubleIAC(s:string):string;
  var
   i:integer;
   l:integer;
   c:integer;
   p:pchar;
   q:pchar;
  begin
   Result:=s;
   l:=Length(s);
   c:=0;
   for i:=1 to l do if s[i]=tnIAC then inc(c);
   if c=0 then exit;
   i:=l+c;
   SetLength(Result,i);
   p:=@Result[i];
   q:=@s[l];
   while c>0 do begin
    if q^=tnIAC then begin
     p^:=tnIAC;
     dec(p);
     dec(c);
    end;
    p^:=q^;
    dec(p);
    dec(q);
   end;
   {
   for i:=length(Result) downto 1 do
    if s[i]=#255 then Insert(#255,Result,i);
   }
  end;

begin
 Frame5250.Status:='Busy...';
 Data:='';
 Head.Size:=Swap(Length(Frame5250.Reply)+10);
 Head.Kind:=$A012;
 Head.Zero:=0;
 Head.Head:=4;
 Head.Flag:=Frame5250.Flags;
 Head.Code:=Frame5250.OpCode;
 SetLength(IAC,SizeOf(Head));
 Move(Head,IAC[1],SizeOf(Head));
 IAC:=DoubleIAC(IAC+Frame5250.Reply)+tnIAC+tnEND;
 fSndBuf:=fSndBuf+IAC;
 WriteSocket;
end;

procedure TForm1.FormCreate(Sender: TObject);
type
 Ttbl=array[#0..#255] of char;
var
 wsa:TWSAData;
 tbl:file of TTbl;
begin
 WSAStartup($101,wsa);
 fSocket:=INVALID_SOCKET;

 Frame5250.OnSend:=DSP5250PutGet;

 Frame5250.Font.Name:=ReadRegString(key,path,'FontName',Frame5250.Font.Name);
 Frame5250.Font.Size:=ReadRegInteger(key,path,'FontSize',Frame5250.Font.Size);
 Frame5250.Color:=ReadRegInteger(key,path,'Black',Frame5250.Color);
 Frame5250.Blink:=ReadRegInteger(key,path,'Blink',Frame5250.Blink);
 Frame5250.Blue:=ReadRegInteger(key,path,'Blue' ,Frame5250.Blue);
 Frame5250.Green:=ReadRegInteger(key,path,'Green',Frame5250.Green);
 Frame5250.Pink :=ReadRegInteger(key,path,'Pink',Frame5250.Pink);
 Frame5250.Red:=ReadRegInteger(key,path,'Red',Frame5250.Red);
 Frame5250.Turquoise:=ReadRegInteger(key,path,'Turquoise',Frame5250.Turquoise);
 Frame5250.White:=ReadRegInteger(key,path,'White',Frame5250.White);
 Frame5250.Yellow:=ReadRegInteger(key,path,'Yellow',Frame5250.Yellow);
{$I-}
 assignfile(tbl,'TN400.TBL');
 reset(tbl);
 if ioresult=0 then begin
  read(tbl,TTbl(E2A));
  read(tbl,TTbl(A2E));
  Frame5250.Status:='User defined Translation table';
  closefile(tbl);
 end;

 SysName:=ParamStr(1);
 DevName:=ParamStr(2);
 if SysName<>'' then begin
  if DevName<>'' then begin
   Top:=ReadRegInteger(key,path+'\'+SysName+'\'+DevName,'Top',Top);
   Left:=ReadRegInteger(key,path+'\'+SysName+'\'+DevName,'Left',Left);
   Width:=ReadRegInteger(key,path+'\'+SysName+'\'+DevName,'Width',Width);
   Height:=ReadRegInteger(key,path+'\'+SysName+'\'+DevName,'Height',Height);
  end;
  CallServer;
 end;

end;

procedure TForm1.About1Click(Sender: TObject);
begin
 ShowMessage('TN400 v3.3b, (C)1999-2005 by Paul TOTH <tothpaul@free.fr>'#13#10+
             'http://tothpaul.free.fr'#13#10+
             'Thanks to Graham Davies for is great contribution !'#13#10+
             #13#10+
             'This program is free software; you can redistribute it and/or'#13#10+
             'modify it under the terms of the GNU General Public License'#13#10+
             'as published by the Free Software Foundation; either version 2'#13#10+
             'of the License, or (at your option) any later version.'#13#10+
             #13#10+
             'This program is distributed in the hope that it will be useful,'#13#10+
             'but WITHOUT ANY WARRANTY; without even the implied warranty of'#13#10+
             'MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the'#13#10+
             'GNU General Public License for more details.'#13#10+
             #13#10+
             'You should have received a copy of the GNU General Public License'#13#10+
             'along with this program; if not, write to the Free Software'#13#10+
             'Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.');

end;

procedure TForm1.Font1Click(Sender: TObject);
begin
 FontDialog1.Font:=Frame5250.Font;
 if FontDialog1.Execute then Frame5250.Font:=FontDialog1.Font;
end;

procedure TForm1.RemoteSystem1Click(Sender: TObject);
begin
 if fSocket=INVALID_SOCKET then begin
  Form2:=TForm2.Create(Application);
  Form2.Left:=Left+(Width-Form2.Width) div 2;
  Form2.Top :=Top+(Height-Form2.Height) div 2;
  if Form2.ShowModal=mrOK then begin
   SysName:=Form2.HostName.Text;
   DevName:=Form2.DeviceName.Text;
   if SysName<>'' then CallServer;
  end;
  Form2.Free;
 end;
end;

procedure TForm1.CallServer;
var
 sa:TSockAddr;
  p:integer;
  s:string;
begin
 Frame5250.Status:='Please wait...';
 fSocket:=socket(AF_INET,SOCK_STREAM,IPPROTO_TCP);
 if fSocket=INVALID_SOCKET then WSError('Impossible d''ouvrir un socket');
 WSAASyncSelect(fSocket,Handle,WM_USER,FD_CONNECT or FD_READ or FD_WRITE or FD_CLOSE);
 FillChar(sa,SizeOf(sa),0);
 sa.sin_family:=AF_INET;
 p:=pos(':',SysName);
 if p>0 then begin
  s:=Copy(SysName,1,p-1);
  p:=StrToInt(copy(SysName,p+1,MaxInt));
 end else begin
  s:=SysName;
  p:=23;
 end;
 sa.sin_addr.S_addr:=INetAddr(s);
 sa.sin_port:=htons(p);
 if connect(fSocket,sa,SizeOf(sa))<>0 then WSError('Unable to connect to server');
end;

procedure TForm1.SaveScreen1Click(Sender: TObject);
begin
 if SaveDlg.Execute then SaveFmt(SaveDlg.FileName);
end;

procedure TForm1.LoadScreen1Click(Sender: TObject);
begin
 if OpenDlg.Execute then begin
  LoadFmt(OpenDlg.FileName);
  ExFmt;
 end;
end;

procedure TForm1.Quit1Click(Sender: TObject);
begin
 Application.Terminate;
end;

procedure TForm1.Black1Click(Sender: TObject);
begin
 Case TMenuItem(Sender).Tag of
  0:ColorDlg.Color:=Frame5250.Color;
  1:ColorDlg.Color:=Frame5250.Blink;
  2:ColorDlg.Color:=Frame5250.Blue;
  3:ColorDlg.Color:=Frame5250.Green;
  4:ColorDlg.Color:=Frame5250.Pink;
  5:ColorDlg.Color:=Frame5250.Red;
  6:ColorDlg.Color:=Frame5250.Turquoise;
  7:ColorDlg.Color:=Frame5250.White;
  8:ColorDlg.Color:=Frame5250.Yellow;
 end;
 if ColorDlg.Execute then begin
  case TMenuItem(Sender).Tag of
   0:Frame5250.Color:=ColorDlg.Color;
   1:Frame5250.Blink:=ColorDlg.Color;
   2:Frame5250.Blue:=ColorDlg.Color;
   3:Frame5250.Green:=ColorDlg.Color;
   4:Frame5250.Pink:=ColorDlg.Color;
   5:Frame5250.Red:=ColorDlg.Color;
   6:Frame5250.Turquoise:=ColorDlg.Color;
   7:Frame5250.White:=ColorDlg.Color;
   8:Frame5250.Yellow:=ColorDlg.Color;
   9:Frame5250.Color:=ColorDlg.Color;
  end;
  Frame5250.Invalidate;
 end;
end;

procedure TForm1.Disconnect1Click(Sender: TObject);
begin
 Disconnected(0);
end;

procedure TForm1.RegisterOptions1Click(Sender: TObject);
begin
 WriteRegString (key,path,'FontName',Frame5250.Font.Name);
 WriteRegInteger(key,path,'FontSize',Frame5250.Font.Size);
 WriteRegInteger(key,path,'Black',Frame5250.Color);
 WriteRegInteger(key,path,'Blink',Frame5250.Blink);
 WriteRegInteger(key,path,'Blue' ,Frame5250.Blue);
 WriteRegInteger(key,path,'Green',Frame5250.Green);
 WriteRegInteger(key,path,'Pink',Frame5250.Pink);
 WriteRegInteger(key,path,'Red',Frame5250.Red);
 WriteRegInteger(key,path,'Turquoise',Frame5250.Turquoise);
 WriteRegInteger(key,path,'White',Frame5250.White);
 WriteRegInteger(key,path,'Yellow',Frame5250.Yellow);
 if fSocket<>INVALID_SOCKET then begin
  WriteRegInteger(key,path+'\'+SysName+'\'+DevName,'Top',Top);
  WriteRegInteger(key,path+'\'+SysName+'\'+DevName,'Left',Left);
  WriteRegInteger(key,path+'\'+SysName+'\'+DevName,'Width',Width);
  WriteRegInteger(key,path+'\'+SysName+'\'+DevName,'Height',Height);
 end;
end;

Function WindowPath(Value:string):string;
 begin
// HKEY_CURRENT_USER\Software\Microsoft\Windows\CurrentVersion\Explorer\Shell Folders
  Result:=ReadRegString(HKEY_CURRENT_USER,'Software\Microsoft\Windows\CurrentVersion\Explorer\Shell Folders',Value,'???');
 end;

procedure TForm1.AddIcon1Click(Sender: TObject);
var
 s:string;
 i:integer;
begin
 if (DevName='')or(SysName='') then begin
  RemoteSystem1Click(Self);
  exit;
 end;
 i:=pos(':',SysName);
 if i>0 then s:=Copy(SysName,1,i-1) else s:=SysName;
 SaveDlg.FileName:=WindowPath('Desktop')+'\'+DevName+' ('+s+').lnk';
 if SaveDlg.Execute then
  CreateLink(SaveDlg.FileName,Application.ExeName,SysName+' '+DevName);
end;

procedure TForm1.HowtoUninstall1Click(Sender: TObject);
begin
 ShowMessage(
  'Remove TN400.EXE,'#13#10+
  'Remove Registry Entry "HKEY_CURRENT_USER\Software\MySoft\TN400"'#13#10+
  'Remove any ShortCut...'#13#10+
  #13#10+
  'That''s all folks !'
 );
end;

procedure TForm1.Usedport1Click(Sender: TObject);
begin
 ShowMessage(
  'TN400 use default telnet port 23.'#13#10+
  'Use an other port with "HostName:port" in the connexion dialog box'
 );
end;

procedure TForm1.Keyboard1Click(Sender: TObject);
begin
 Form3.Show;
end;

procedure TForm1.Disconnected(ErrNo:integer);
begin
 Frame5250.Lock;
 Frame5250.Status:='Offline';
 Disconnect1.Enabled:=False;
 RemoteSystem1.Enabled:=True;
 CloseSocket(fSocket);
 fSocket:=INVALID_SOCKET;
end;

procedure TForm1.Copy1Click(Sender: TObject);
begin
 Frame5250.CopyFields;
end;

procedure TForm1.Past1Click(Sender: TObject);
begin
 Frame5250.PastFields;
end;

procedure TForm1.ExportasHTML1Click(Sender: TObject);
var
 s:TStringList;
begin
 savedialog1.filename:=DevName+'.htm';
 if savedialog1.execute then begin
  s:=TStringList.Create;
  Frame5250.CopyAsHtml(s);
  s.SaveToFile(savedialog1.filename);
  s.free;
 end;
end;

procedure TForm1.ShowAttributes1Click(Sender: TObject);
begin
 Frame5250.ShowAttr:=ShowAttributes1.Checked;
 Frame5250.Invalidate;
end;

procedure TForm1.Copyastext1Click(Sender: TObject);
begin
 Clipboard.AsText:=Frame5250.AsText;
end;

type
// to call a protected method of TClipboard (SetBuffer)
 TOpenClipboard=class(TClipboard)
 end;

procedure TForm1.Copyashtml1Click(Sender: TObject);
var
 htm:string;
 fmt:integer;
 start,stop:integer;

 procedure fixSize(Tag:string; Size:integer);
 var
  i:integer;
 begin
  i:=pos(Tag,htm);
  if i=0 then exit;
  inc(i,length(Tag)+4);
  while size>0 do begin
   htm[i]:=chr(ord('0')+Size mod 10);
   Size:=Size div 10;
   dec(i);
  end;
 end;

begin
 htm:='Version:1.0'#13#10
     +'StartHTML:00000'#13#10
     +'EndHTML:00000'#13#10
     +'StartFragment:00000'#13#10
     +'EndFragment:00000'#13#10
     +'StartSelection:00000'#13#10
     +'EndSelection:00000'#13#10
     +Frame5250.AsHtml+#0;
 start:=pos('<!--StartFragment-->',htm);
 stop :=pos('<!--EndFragment-->',htm);
 fixSize('StartHTML:',pos('<',htm)-1);
 fixSize('EndHTML:',length(htm)-1);
 fixSize('StartFragment:',start);
 fixSize('EndFragment:',stop);
 fixSize('StartSelection:',start);
 fixSize('EndSelection:',stop);
 fmt:=RegisterClipboardFormat('HTML Format');
 TOpenClipboard(Clipboard).SetBuffer(fmt,htm[1],length(htm));
end;

procedure TForm1.Copyasbitmap1Click(Sender: TObject);
var
 Bitmap:TBitmap;
begin
 Bitmap:=TBitmap.Create;
 try
  Bitmap.PixelFormat:=pf8bit;
  Bitmap.Width:=Frame5250.ClientWidth;
  Bitmap.Height:=Frame5250.ClientHeight;
  Frame5250.PaintTo(Bitmap.Canvas,0,0);
  Clipboard.Assign(Bitmap);
 finally
  Bitmap.Free;
 end;
end;

end.
